diff --git a/drivers/acpi/arm64/amba.c b/drivers/acpi/arm64/amba.c
index 1350083bce5f..8d27d86ee052 100644
--- a/drivers/acpi/arm64/amba.c
+++ b/drivers/acpi/arm64/amba.c
@@ -33,8 +33,7 @@ static void amba_register_dummy_clk(void)
 	clk_register_clkdev(amba_dummy_clk, "apb_pclk", NULL);
 }
 
-static int amba_handler_attach(struct acpi_device *adev,
-				const struct acpi_device_id *id)
+static int amba_handler_attach(struct acpi_device *adev, const struct acpi_device_id *id)
 {
 	struct acpi_device *parent = acpi_dev_parent(adev);
 	struct amba_device *dev;
@@ -94,7 +93,7 @@ static int amba_handler_attach(struct acpi_device *adev,
 	ret = amba_device_add(dev, &iomem_resource);
 	if (ret) {
 		dev_err(&adev->dev, "%s(): amba_device_add() failed (%d)\n",
-		       __func__, ret);
+			__func__, ret);
 		goto err_free;
 	}
 
diff --git a/drivers/acpi/arm64/apmt.c b/drivers/acpi/arm64/apmt.c
index bb010f6164e5..74e8dc33241b 100644
--- a/drivers/acpi/arm64/apmt.c
+++ b/drivers/acpi/arm64/apmt.c
@@ -48,7 +48,7 @@ static int __init apmt_init_resources(struct resource *res,
 		trigger = (trigger == ACPI_APMT_OVFLW_IRQ_FLAGS_MODE_LEVEL) ?
 			ACPI_LEVEL_SENSITIVE : ACPI_EDGE_SENSITIVE;
 		irq = acpi_register_gsi(NULL, node->ovflw_irq, trigger,
-						ACPI_ACTIVE_HIGH);
+					ACPI_ACTIVE_HIGH);
 
 		if (irq <= 0) {
 			pr_warn("APMT could not register gsi hwirq %d\n", irq);
@@ -132,7 +132,7 @@ static int __init apmt_init_platform_devices(void)
 
 	while (offset < end) {
 		apmt_node = ACPI_ADD_PTR(struct acpi_apmt_node, apmt,
-				 offset);
+					 offset);
 
 		fwnode = acpi_alloc_fwnode_static();
 		if (!fwnode)
diff --git a/drivers/acpi/arm64/iort.c b/drivers/acpi/arm64/iort.c
index 1b39e9ae7ac1..369a3b506711 100644
--- a/drivers/acpi/arm64/iort.c
+++ b/drivers/acpi/arm64/iort.c
@@ -374,7 +374,7 @@ static struct acpi_iort_node *iort_node_get_id(struct acpi_iort_node *node,
 	struct acpi_iort_id_mapping *map;
 
 	if (!node->mapping_offset || !node->mapping_count ||
-				     index >= node->mapping_count)
+	    index >= node->mapping_count)
 		return NULL;
 
 	map = ACPI_ADD_PTR(struct acpi_iort_id_mapping, node,
@@ -388,7 +388,7 @@ static struct acpi_iort_node *iort_node_get_id(struct acpi_iort_node *node,
 	}
 
 	parent = ACPI_ADD_PTR(struct acpi_iort_node, iort_table,
-			       map->output_reference);
+			      map->output_reference);
 
 	if (map->flags & ACPI_IORT_ID_SINGLE_MAPPING) {
 		if (node->type == ACPI_IORT_NODE_NAMED_COMPONENT ||
@@ -1128,8 +1128,8 @@ static void iort_iommu_msi_get_resv_regions(struct device *dev,
 
 	for (i = 0; i < fwspec->num_ids; i++) {
 		its_node = iort_node_map_id(iommu_node,
-					fwspec->ids[i],
-					NULL, IORT_MSI_TYPE);
+					    fwspec->ids[i],
+					    NULL, IORT_MSI_TYPE);
 		if (its_node)
 			break;
 	}
@@ -1429,7 +1429,7 @@ static void __init acpi_iort_register_irq(int hwirq, const char *name,
 
 	if (irq <= 0) {
 		pr_err("could not register gsi hwirq %d name [%s]\n", hwirq,
-								      name);
+		       name);
 		return;
 	}
 
@@ -1561,7 +1561,7 @@ static void __init arm_smmu_v3_dma_configure(struct device *dev,
  * set numa proximity domain for smmuv3 device
  */
 static int  __init arm_smmu_v3_set_proximity(struct device *dev,
-					      struct acpi_iort_node *node)
+					     struct acpi_iort_node *node)
 {
 	struct acpi_iort_smmu_v3 *smmu;
 
@@ -1622,7 +1622,7 @@ static void __init arm_smmu_init_resources(struct resource *res,
 	trigger = IORT_IRQ_TRIGGER_MASK(glb_irq[0]);
 
 	acpi_iort_register_irq(hw_irq, "arm-smmu-global", trigger,
-				     &res[num_res++]);
+			       &res[num_res++]);
 
 	/* Context IRQs */
 	ctx_irq = ACPI_ADD_PTR(u64, node, smmu->context_interrupt_offset);
@@ -1727,9 +1727,9 @@ struct iort_dev_config {
 				  struct acpi_iort_node *node);
 	int (*dev_count_resources)(struct acpi_iort_node *node);
 	void (*dev_init_resources)(struct resource *res,
-				     struct acpi_iort_node *node);
+				   struct acpi_iort_node *node);
 	int (*dev_set_proximity)(struct device *dev,
-				    struct acpi_iort_node *node);
+				 struct acpi_iort_node *node);
 	int (*dev_add_platdata)(struct platform_device *pdev);
 };
 
@@ -1878,13 +1878,13 @@ static void __init iort_enable_acs(struct acpi_iort_node *iort_node)
 				continue;
 
 			parent = ACPI_ADD_PTR(struct acpi_iort_node,
-					iort_table,  map->output_reference);
+					      iort_table,  map->output_reference);
 			/*
 			 * If we detect a RC->SMMU mapping, make sure
 			 * we enable ACS on the system.
 			 */
 			if ((parent->type == ACPI_IORT_NODE_SMMU) ||
-				(parent->type == ACPI_IORT_NODE_SMMU_V3)) {
+			    (parent->type == ACPI_IORT_NODE_SMMU_V3)) {
 				pci_request_acs();
 				acs_enabled = true;
 				return;